# Инструменты для работы с шрифтом

Для работы с шрифтом нужно использовать слежующую схему:
1. Чтение шрифта из файла BIOS при помощи скрипта [font-to-text.py](#fonttotext)
2. Имзменеия шрифта в текстовом файле
3. Сохрание шрифта в бинарный файл [text-to-font.py](#texttofont)
4. [Изменение исходного файла BIOS](#fonttobios)

<a name="fonttotext"></a>
### font-to-text.py
Чтение файла BIOS и сохранение шрифта в текстовый файл.

Параметры:
1. Исходный файл BIOS
2. Файл для сохранения шрифта

Пример запуска:
`./font-to-text.py file.bin font.txt`

Двоичные числа описывающие биты заменяются на символы:

Число | Замена
----- | -----
  0   |   . 
  1   |   @ 


Примеры отображения символов с текстовом файле:
```
Смещение: 0x8 (8)   Код: 0x01 (1)
_12345678
1..@@@@..
2.@....@.
3@.@..@.@
4@......@
5@.@..@.@
6@..@@..@
7.@....@.
8..@@@@..

…

Смещение: 0x1FB7   Код: 0x7F (127)
_12345678
1........
2........
3..@.....
4.@.@....
5@@@@@...
6........
7........
8........

```
<a name="texttofont"></a>
### text-to-font.py
Чтение шрифта из текстового файла и вывод в бинарный формат.

Параметры:
1. Файл шрифта в текстовом формате
2. Файл для сохранения шрифта в бинарном формате

Пример запуска:
`./text-to-font.py font.txt font`

<a name="fonttobios"></a>
### Изменение исходного файла BIOS
Для изменения исходного файла BIOS используйте команду:
`../tools/fragment-to-binary-file.py file.bin file_1BBF-2048.bin 1BBF 2048`

### Дополнительно
Чтение файла BIOS и сохранение фрагмента с шрифтом в отдельный файл:

`../tools/fragment-from-binary-file.py file.bin font.bin 1BBF 2048`
